#include <qobject.h>

#include "../../../Core/Scene/src/Scene.h"

#include "ICP_Plugin.h"

// ******************
// 'What's this' text
// ******************

static const char *whatsThisText = "This is the ICP plugin.<br>"
"It implements the <i>iterative corresponding point</i> algorithm "
"for robust simultaneous registration of multiple objects."
"<ul><li>Input: more than one object.</li>"
"<li>Output: transformed objects.</li></ul>";

// **************
// public methods
// **************

ICP_Plugin::ICP_Plugin() {}
ICP_Plugin::~ICP_Plugin() {}

void ICP_Plugin::execute() {

	ICP_Dialog* dialog = ICP_Dialog::getInstance();
	dialog->show();
	dialog->raise();

}


bool ICP_Plugin::isAvailable() const {
	return this->checkPluginAvailability();
}

// ***************
// private methods
// ***************

bool ICP_Plugin::checkPluginAvailability() const {
	return (Scene::getInstance()->getNofObjects() > 1);
}

// ****************
// access functions
// ****************

PLUGIN_API PluginInterface *createPlugin() {
	return new ICP_Plugin();
}

PLUGIN_API const char *getPluginName() {
	return "ICP...";
}

PLUGIN_API const char *getPluginDescription() {
	return whatsThisText;
}

